﻿using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using System.Collections.Generic;
using System;
using System.ComponentModel;
using System.Linq;
using System.Collections.ObjectModel;

namespace RadGridView_WPF_2009_Q2_SP113
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        List<Player> players = new List<Player>();
        BackgroundWorker worker = new BackgroundWorker();

        public Window1()
        {
            InitializeComponent();

            for (int i = 0; i < 5000; i++)
            {
                var newPLayer = new Player(i.ToString(), i, Position.DF, i.ToString());
                players.Add(newPLayer);
            }
            
            this.playersGrid.ItemsSource = players;
            this.playersGrid.MultipleSelect = true;
            this.worker.DoWork += new DoWorkEventHandler(worker_DoWork);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.worker.RunWorkerAsync(this.players.Take(1000));
        }

        void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            var playersToSelect = e.Argument as IEnumerable<Player>;

            foreach (var item in playersToSelect)
            {
                this.Dispatcher.Invoke(new Action(() => this.playersGrid.SelectedItems.Add(item)), 
                    System.Windows.Threading.DispatcherPriority.ApplicationIdle, null);
            }
        }
    }
}
